
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdarg.h>

#define	XFOPEN_FS 0x01
#define	XFOPEN_DB 0x02

int xCVS_ACCESS(const char *pathname, int mode);
int xCVS_CHDIR(const char *path);
int xCVS_CREAT(const char *pathname, mode_t mode);
FILE *xCVS_FOPEN(const char *path, const char *mode, char *file, int line);
FILE *xCVS_ADMFOPEN(const char *path, const char *mode, char *file, int line);
FILE *xCVS_XFOPEN(int, const char *path, const char *mode, char *file, int line);
FILE *xCVS_FDOPEN(int fildes, const char *mode);
int xCVS_MKDIR(const char *pathname, mode_t mode);
int xCVS_OPEN(const char *pathname, int flags, mode_t mode);
struct dirent *xCVS_READDIR(DIR *dir);
int xCVS_CLOSEDIR(DIR *dir);
DIR *xCVS_OPENDIR(const char *name);
int xCVS_RENAME(const char *oldpath, const char *newpath);
int xCVS_RMDIR(const char *pathname);
int xCVS_STAT(const char *file_name, struct stat *buf, char *file, int line);
int xCVS_LSTAT(const char *file_name, struct stat *buf, char *file, int line);
int xCVS_UNLINK(const char *pathname);
int xCVS_FNMATCH(const char *pattern, const char *string, int flags);

size_t xCVS_FREAD(void *ptr, size_t size, size_t nmemb, FILE *stream);
size_t xCVS_FWRITE(const void *ptr, size_t size, size_t nmemb, FILE *stream);
int xCVS_FEOF(FILE *stream);
int xCVS_FERROR(FILE *stream);
				/* fileno */
int xCVS_FCLOSE(FILE *stream);
char *xCVS_FGETS(char *s, int size, FILE *stream);
int xCVS_FPUTS(const char *s, FILE *stream);
int xCVS_FFLUSH(FILE *stream);
int xCVS_VFPRINTF(FILE *stream, const char *format, va_list va);
int xCVS_FPRINTF(FILE *stream, const char *format, ...);

int xCVS_CHMOD(const char *path, mode_t mode);
ssize_t xCVS_GETLINE(char **lineptr, size_t *n, FILE *stream);
int xCVS_GETC(FILE *stream);
int xCVS_PUTC(int c, FILE *stream);

int xCVS_FSTAT_FILENO(FILE *stream, struct stat *buf);

char *cvsDB_expandpath(const char *);
// FILE *x_fopen(const char *path, const char *mode);


#define CVS_ACCESS xCVS_ACCESS
#define CVS_CHDIR xCVS_CHDIR
#define CVS_CREAT xCVS_CREAT
// #define CVS_FOPEN xCVS_FOPEN
#define CVS_FOPEN(_p,_m) xCVS_FOPEN((_p),(_m), __FILE__, __LINE__)
#define CVS_ADMFOPEN(_p,_m) xCVS_ADMFOPEN((_p),(_m), __FILE__, __LINE__)
#define CVS_XFOPEN(_h,_p,_m) xCVS_XFOPEN((_h),(_p),(_m), __FILE__, __LINE__)
#define CVS_FDOPEN xCVS_FDOPEN
#define CVS_MKDIR xCVS_MKDIR
#define CVS_OPEN xCVS_OPEN
#define CVS_READDIR xCVS_READDIR
#define CVS_CLOSEDIR xCVS_CLOSEDIR
#define CVS_OPENDIR xCVS_OPENDIR
#define CVS_RENAME xCVS_RENAME
#define CVS_RMDIR xCVS_RMDIR
// #define CVS_STAT xCVS_STAT
#define CVS_STAT(_f,_b) xCVS_STAT((_f),(_b), __FILE__, __LINE__)
// #define CVS_LSTAT xCVS_LSTAT
#define CVS_LSTAT(_f,_b) xCVS_LSTAT((_f),(_b), __FILE__, __LINE__)
#define CVS_UNLINK xCVS_UNLINK
#define CVS_FNMATCH xCVS_FNMATCH

#define	CVS_FREAD xCVS_FREAD
#define	CVS_FWRITE xCVS_FWRITE
#define	CVS_FEOF xCVS_FEOF
#define	CVS_FERROR xCVS_FERROR
#define	CVS_FCLOSE xCVS_FCLOSE
#define	CVS_FGETS xCVS_FGETS
#define	CVS_FPUTS xCVS_FPUTS
#define	CVS_FFLUSH xCVS_FFLUSH
#define	CVS_VFPRINTF xCVS_VFPRINTF
#define	CVS_FPRINTF xCVS_FPRINTF

#define	CVS_CHMOD xCVS_CHMOD
#define	CVS_GETLINE xCVS_GETLINE
#define	CVS_GETC xCVS_GETC
#define	CVS_PUTC xCVS_PUTC

#define CVS_FSTAT_FILENO xCVS_FSTAT_FILENO


#define	TRACE_ALWAYS 0
#define	TRACE_RUN 1
#define	TRACE_FLOW 2

void TRACE(int level, const char *fmt, ...);

